#ifndef BLOCKMAP_H
#define BLOCKMAP_H

#include "gaming-core/utils/BitArray.h"
#include "gaming-core/utils/Array.h"
#include "common/block/BlockTypes.h"

template<int N, int B>
class BlockMap {
    static constexpr int EMPTY_BLOCK_ID = 65535;

    BitArray<N, B> blocks;
    Array<BlockId, 1 << B> map;

public:

    BlockMap(BlockId id) : map(EMPTY_BLOCK_ID) {
        map[0] = id;
    }

    BlockId get(int index) const {
        return map[blocks[index]];
    }

    bool set(int index, BlockId id) {
        for(int i = 0; i < map.getLength(); i++) {
            if(map[i] == id) {
                blocks[index] = i;
                return false;
            } else if(map[i] == 65535) {
                map[i] = id;
                blocks[index] = i;
                return false;
            }
        }
        return true;
    }
};

#endif